## z88dk 1.8.ds1

=== Makefile ===
#
#
#	The impromptu compilation makefile for z88dk
#
#	$Id: Makefile,v 1.32 2008/03/01 15:06:51 dom Exp $
#

# ---> Configurable parameters are below his point

prefix = /usr/local
prefix_share = $(prefix)/share

# The default machine, the lib/config/DEFAULT.cfg file is copied to zcc.cfg
DEFAULT = z88

# --> End of Configurable Options

all: setup appmake copt zcpp sccz80 z80asm zcc config

# setenv CC "dcc -unixrc -mC -mD"
# make -e amiga
amiga:  clean-bins
	# Now build the Amiga binaries
	echo '#define PREFIX "zcc:"' > src/config.h
	echo '#define AMIGA 1' >> src/config.h
	mkdir -p z88dk/bin 
	$(MAKE) -C src/appmake 
	$(MAKE) -C src/appmake install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/appmake clean
	$(MAKE) -C src/copt 
	$(MAKE) -C src/copt install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/copt clean
	$(MAKE) -C src/cpp 
	$(MAKE) -C src/cpp install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/cpp clean
	$(MAKE) -C src/sccz80 
	$(MAKE) -C src/sccz80 install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/sccz80 clean
	$(MAKE) -C src/z80asm 
	$(MAKE) -C src/z80asm install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/z80asm clean
	$(MAKE) -C src/zcc  
	$(MAKE) -C src/zcc install PREFIX=`pwd`/z88dk
	$(MAKE) -C src/zcc clean
	$(MAKE) -C libsrc clean
	./config.sh zcc: z88
	cp -R  libsrc/ include/ lib/ examples/ doc/ support/ src/ z88dk/
	cp amiga.patch EXTENSIONS LICENSE Makefile amigabuild.sh z88dk/
	cp README.1st z88dk/
	cd z88dk ; patch -p0 < amiga.patch


setup:
	echo '#define PREFIX "${prefix}$"/lib/z88dk"' > src/config.h
	echo '#define UNIX 1' >> src/config.h

appmake:
	$(MAKE) -C src/appmake
	$(MAKE) -C src/appmake PREFIX=`pwd` install

copt:
	$(MAKE) -C src/copt
	$(MAKE) -C src/copt PREFIX=`pwd` install

zcpp:
	$(MAKE) -C src/cpp
	$(MAKE) -C src/cpp PREFIX=`pwd` install

sccz80:
	$(MAKE) -C src/sccz80
	$(MAKE) -C src/sccz80 PREFIX=`pwd` install

z80asm:
	echo 'Configure z80asm for ENDIAN status!!'
	$(MAKE) -C src/z80asm
	$(MAKE) -C src/z80asm PREFIX=`pwd` install

zcc:
	$(MAKE) -C src/zcc
	$(MAKE) -C src/zcc PREFIX=`pwd` install

config:
	./config.sh `pwd`/ $(DEFAULT)

libs:
	cd libsrc ; $(MAKE)
	cd libsrc ; $(MAKE) install

install-libs:
	mkdir -p $(prefix)/lib/z88dk/lib/clibs
	cp -R lib/clibs/* $(prefix)/lib/z88dk/lib/clibs/
	find $(prefix)/lib/z88dk/lib/clibs -type f | xargs chmod 644


install:
	mkdir -p -m 755 $(DESTDIR)/$(prefix)/bin $(DESTDIR)/$(prefix_share)/z88dk
	mkdir -p -m 755 $(DESTDIR)/$(prefix_share)/z88dk/lib
	mkdir -p -m 755 $(DESTDIR)/$(prefix_share)/z88dk/lib/clibs 
	mkdir -p -m 755 $(DESTDIR)/$(prefix_share)/z88dk/lib/config
	cd src/appmake ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	cd src/copt ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	cd src/cpp ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	cd src/sccz80 ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	cd src/z80asm ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	cd src/zcc ; $(MAKE) PREFIX=$(DESTDIR)/$(prefix) install
	./config.sh $(prefix_share)/z88dk/ $(DEFAULT)
	cp -R -p include $(DESTDIR)/$(prefix_share)/z88dk
	cp -R -p lib $(DESTDIR)/$(prefix_share)/z88dk
	find $(DESTDIR)/$(prefix_share)/z88dk -type f -exec chmod 644 {} \;
	find $(DESTDIR)/$(prefix_share)/z88dk -type d -exec chmod 755 {} \;

clean: clean-bins
	cd libsrc ; $(MAKE) clean
	cd lib/config ; $(RM) *.cfg
	cd lib/clibs ; $(RM) *.lib
	find . -name "*.o" -type f -exec rm -f {} \;

clean-bins:
	cd src/appmake ; $(MAKE) clean
	cd src/copt ; $(MAKE) clean
	cd src/cpp ; $(MAKE) clean
	cd src/sccz80 ; $(MAKE) clean
	cd src/z80asm ; $(MAKE) clean
	cd src/zcc ; $(MAKE) clean

=== libsrc/Makefile ===
#
# Ah, that'd be nice, a library makefile!
#
# Problems? Contact the person to blame(!) above the section
# for the library
#
# $Id: Makefile,v 1.111 2008/03/04 11:31:10 aralbrec Exp $


include Make.config

# LIBRARIES not built by the global list below:
# - SP1 (build depends on customization and machine target, "make sp1" for options)

all:	genlibs z88libs tilibs zxlibs \
	debug.lib \
	nc_clib.lib vz_clib.lib vzansi_clib.lib \
	abc80_clib.lib abc80ansi_clib.lib abc800_clib.lib \
	aceansi_clib.lib aquarius_clib.lib aquansi_clib.lib \
	cpc_clib.lib cpcansi_clib.lib cpcfs.lib cpc_math.lib cpcgray.lib \
	cpm_clib.lib c128ansi_clib.lib \
	m5_clib.lib msx_clib.lib mz_clib.lib mzansi_clib.lib \
	nascom_clib.lib nasansi_clib.lib newbrain_clib.lib \
	ozansi_clib.lib rex_clib.lib rcmx000_clib.lib \
	svi_clib.lib sam_clib.lib samansi_clib.lib \
	pps_clib.lib ppsansi_clib.lib embedded_clib.lib \
	test_clib.lib sms_clib.lib \
	zx81libs

genlibs: gen_math.lib malloc.lib z80_crt0.lib ndos.lib adt.lib balloc.lib \
         im2.lib rect.lib algorithm.lib

z88libs: z88_math.lib z88.lib z88_clib.lib net.lib z88net_clib.lib farz88.lib \
	 z88ansi_clib.lib gfx.lib 

tilibs: ti82ansi_clib.lib ti82_clib.lib ti83ansi_clib.lib ti83_clib.lib \
	ti83pansi_clib.lib ti83p_clib.lib ti85ansi_clib.lib ti85_clib.lib \
	ti86ansi_clib.lib ti86_clib.lib \
	tigray82.lib tigray83.lib tigray83p.lib tigray85.lib tigray86.lib

zxlibs: ts2068_clib.lib zx_clib.lib zxan_clib.lib ts2068an_clib.lib zxvgs.lib mzx.lib mzx_tiny.lib

zx81libs: zx81_clib.lib zx81ansi_clib.lib gfx81.lib gfx81hr64.lib gfx81hr192.lib m81.lib m81_tiny.lib

# moving external shell scripts to makefile to make life easy on
# the windows platform devs (ie Me :-) -- gamesdeps.sh, gfxdeps.sh, tideps.sh

#  short script to sort out games dependencies
gamesdeps:
	$(RM) -f games/*.o

#  short script to sort out gfx dependencies
gfxdeps:
	$(RM) -f graphics/*.o
	$(RM) -f graphics/ticalc/*.o
	$(RM) -f graphics/gray/*.o
	$(RM) -f graphics/gray/ticalc/*.o
	$(RM) -f graphics/spectrum/*.o
	$(RM) -f graphics/z88/*.o
	$(RM) -f graphics/text/*.o
	$(RM) -f graphics/text6/*.o
	cd graphics ; $(MAKE) ; cd ..

#  short script to sort out ticalc dependencies
tideps:
	$(RM) -f stdio/ticalc/*.o
	$(RM) -f stdio/ansi/ticalc/*.o
	$(RM) -f games/*.o
	$(RM) -f games/ticalc/*.o
	$(RM) -f graphics/*.o
	$(RM) -f graphics/ticalc/*.o
	$(RM) -f graphics/gray/*.o
	$(RM) -f graphics/gray/ticalc/*.o

zx81deps:
	$(RM) -f strings/*.o
	$(RM) -f stdlib/*.o
	$(RM) -f stdio/*.o
	$(RM) -f stdio/ansi/zx81/*.o
	$(RM) -f input/spectrum/*.o
	$(RM) -f input/zx81/*.o
	$(RM) -f games/*.o
	$(RM) -f graphics/*.o
	$(RM) -f graphics/zx81/*.o
	$(RM) -f graphics/zx81/hr/*.o
	$(RM) -f graphics/gray/*.o

# interesting algorithms - aralbrec
algorithm.lib:
	@echo ''
	@echo '--- Building Algorithm Library  ---'
	@echo ''
	cd algorithm ; $(MAKE) ; cd ..

# rectangles, intervals and points - aralbrec
rect.lib:
	@echo ''
	@echo '--- Building Rectangles Library  ---'
	@echo ''
	cd rect ; $(MAKE) ; cd ..

# abstract data types library - aralbrec
adt.lib:
	@echo ''
	@echo '--- Building Abstract Data Types Library  ---'
	@echo ''
	cd adt ; $(MAKE) ; cd ..

# block memory allocator - aralbrec
balloc.lib:
	@echo ''
	@echo '--- Building Block Memory Allocator Library  ---'
	@echo ''
	cd balloc ; $(MAKE) ; cd ..

# interrupt mode 2 library - aralbrec
im2.lib:
	@echo ''
	@echo '--- Building IM 2 Library  ---'
	@echo ''
	cd im2 ; $(MAKE) ; cd ..

# Garry's z88 far library - garry (probably dom now)
farz88.lib:
	@echo ''
	@echo '--- Building Z88 Far Malloc Library  ---'
	@echo ''
	cd farz88 ; $(MAKE) ; cd ..

# Generic maths build - dom
gen_math.lib:
	@echo ''
	@echo '--- Building Z80 Generic Maths Library  ---'
	@echo ''
	cd genmath; $(MAKE) ; cd ..

# Z88 maths build - dom
z88_math.lib:
	@echo ''
	@echo '--- Building Z88 Maths Library  ---'
	@echo ''
	cd z88math; $(MAKE) ; cd ..

# Graphics library (for both app and basic - diff libs though!) - dom
gfx.lib:
	@echo ''
	@echo '--- Building Z88 BASIC gfx Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	$(LIBLINKER) -x$(OUTPUT_DIRECTORY)/gfx -DFORz88 @$(LISTFILE_DIRECTORY)/z88gfx.lst
	$(MAKE) gfxdeps
	$(LIBLINKER) -x$(OUTPUT_DIRECTORY)/gfxapp -DAPPZ88 -DFORz88 @$(LISTFILE_DIRECTORY)/z88gfx.lst

# simple malloc library - dom
# adding multiple heaps and realloc - aralbrec
malloc.lib:
	@echo ''
	@echo '--- Building Near Malloc Library  ---'
	@echo ''
	cd malloc ; $(MAKE) ; cd ..

ndos.lib:
	cd fcntl/dummy ; $(MAKE) ; cd ../..

# Startup code (such as division etc) common to all z80s - dom
z80_crt0.lib:
	@echo ''
	@echo '--- Building Z80 crt0 Library  ---'
	@echo ''
	cd z80_crt0s ; $(MAKE) ; cd ..

# Z88DK DEBUG utilities
debug.lib:
	@echo ''
	@echo '--- Building DEBUG Library  ---'
	@echo ''
	cd debug ; $(MAKE) ; cd ..

# Custom z88 routines for application - dom
z88.lib:
	@echo ''
	@echo '--- Building Z88 Custom Library  ---'
	@echo ''
	cd z88 ; $(MAKE) ; cd ..

# ZSock API (wrappers to package calls) - dom
net.lib:
	@echo ''
	@echo '--- Building Z88 ZSock Library  ---'
	@echo ''
	cd net ; $(MAKE) ; cd ..

# z88 library - dom
z88_clib.lib:
	@echo ''
	@echo '--- Building Z88 Library  ---'
	@echo ''
	cd fcntl ; $(MAKE) lz88 ; cd ..
	cd stdio ; $(MAKE) lz88 ; cd ..
	cd stdlib ; $(MAKE) lz88 ; cd ..
	cd strings ; $(MAKE) ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lz88 ; cd ..
	cd rs232 ; $(MAKE) lz88 ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	$(MAKE) gamesdeps
	cd games ; $(MAKE) lz88 ; cd ..
	$(LIBLINKER) -DFORz88 -x$(OUTPUT_DIRECTORY)/z88_clib @$(LISTFILE_DIRECTORY)/z88.lst

# z88 ansi library - dom
z88ansi_clib.lib:
	@echo ''
	@echo '--- Building Z88 ANSI Library  ---'
	@echo ''
	cd fcntl ; $(MAKE) lz88 ; cd ..
	cd stdio ; $(MAKE) lz88 ; cd ..
	cd stdlib ; $(MAKE) lz88 ; cd ..
	cd strings ; $(MAKE) ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lz88 ; cd ..
	cd rs232 ; $(MAKE) lz88 ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	$(LIBLINKER) -x$(OUTPUT_DIRECTORY)/z88ansi_clib @$(LISTFILE_DIRECTORY)/z88ansi.lst

# Network stdio - dom
z88net_clib.lib:
	@echo ''
	@echo '--- Building Z88 Network Aware Library  ---'
	@echo ''
	cd fcntl ; $(MAKE) lz88 ; cd ..
	cd stdio ; $(MAKE) lz88net ; cd ..
	cd stdlib ; $(MAKE) lz88 ; cd ..
	cd strings ; $(MAKE) ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lz88 ; cd ..
	cd rs232 ; $(MAKE) lz88 ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	$(LIBLINKER) -x$(OUTPUT_DIRECTORY)/z88net_clib @$(LISTFILE_DIRECTORY)/z88net.lst

# 64/32 column library for ZX Spectrum - dom/stefano
zx_clib.lib:
	@echo ''
	@echo '--- Building ZX Spectrum Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lzx ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lzx ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx -x$(OUTPUT_DIRECTORY)/zx_clib @$(LISTFILE_DIRECTORY)/zx.lst

# 64/32 column library for TS2068 - dom/stefano/alvin
ts2068_clib.lib:
	@echo ''
	@echo '--- Building TS2068 (Spectrum clone) Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lzx ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lzx ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx -x$(OUTPUT_DIRECTORY)/ts2068_clib @$(LISTFILE_DIRECTORY)/ts2068.lst

# ZXVGS - yarek
zxvgs.lib:
	@echo ''
	@echo '--- Building ZXVGS Library  ---'
	@echo ''
	cd fcntl ; $(MAKE) lzxvgs ; cd ..
	cd zxvgs; $(MAKE) ; cd ..
	$(LIBLINKER) -DFORzx -x$(OUTPUT_DIRECTORY)/zxvgs @$(LISTFILE_DIRECTORY)/zxvgs.lst

# ZX Spectrum maths library - Stefano
mzx.lib:
	@echo ''
	@echo '--- Building ZX Spectrum Maths Library ---'
	@echo ''
	cd zxmath ; $(MAKE) mzx ; cd ..

mzx_tiny.lib:
	@echo ''
	@echo '--- Building ZX Spectrum Tiny Maths Library ---'
	@echo ''
	cd zxmath ; $(MAKE) mzx_tiny ; cd ..

# vt100 for sprinter - dom
ppsansi_clib.lib:
	@echo ''
	@echo '--- Building Sprinter Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lpps ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lpps ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx -x$(OUTPUT_DIRECTORY)/ppsansi_clib @$(LISTFILE_DIRECTORY)/ppsansi.lst

# Native for sprinter - dom
pps_clib.lib:
	@echo ''
	@echo '--- Building Sprinter Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lpps ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lpps ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) lzx ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx -x$(OUTPUT_DIRECTORY)/pps_clib @$(LISTFILE_DIRECTORY)/pps.lst

# vt100 C lib for spectrum - stefano/dom
# use -DROMFONT for a tiny 36 columns mode
# or -DPACKEDFONT for tiny 64->85 column modes
zxan_clib.lib:
	@echo ''
	@echo '--- Building ZX Spectrum ANSI Library  ---'
	@echo ''
	$(RM) stdio/ansi/spectrum/f_ansi_char.o
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lzx ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lzx ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx $(COLDEFS) -x$(OUTPUT_DIRECTORY)/zxan_clib @$(LISTFILE_DIRECTORY)/zxansi.lst

# vt100 C lib for TS2068 - stefano/dom
# use -DROMFONT for a tiny 36 columns mode
# or -DPACKEDFONT for tiny 64->85 column modes
ts2068an_clib.lib:
	@echo ''
	@echo '--- Building TS2068 (Spectrum clone) ANSI Library  ---'
	@echo ''
	$(RM) stdio/ansi/spectrum/f_ansi_char.o
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) lzx ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd fcntl ; $(MAKE) lzx ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	cd time ; $(MAKE) lzx ; cd ..
	cd rs232 ; $(MAKE) lzx ; cd ..
	$(MAKE) gamesdeps
	cd spectrum ; $(MAKE) ; cd ..
	cd games ; $(MAKE) lzx ; cd ..
	$(LIBLINKER) -DFORzx $(COLDEFS) -x$(OUTPUT_DIRECTORY)/ts2068an_clib @$(LISTFILE_DIRECTORY)/ts2068an.lst

# Untested C lib for NC100 machines - dom
nc_clib.lib:
	@echo ''
	@echo '--- Building Amstrad NC100 Library  ---'
	@echo ''
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) gen ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	$(LIBLINKER) -x$(OUTPUT_DIRECTORY)/nc_clib @$(LISTFILE_DIRECTORY)/nc100.lst

# VZ200/300 lib - Stefano
vz_clib.lib:
	@echo ''
	@echo '--- Building VZ200/300 Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) gen ; cd ..
	cd stdio ; $(MAKE) generic ; cd ..
	cd printflike ; $(MAKE) ; cd ..
	cd setjmp ; $(MAKE) ; cd ..
	cd assert ; $(MAKE) ; cd ..
	$(LIBLINKER) -DFORvz -x$(OUTPUT_DIRECTORY)/vz_clib @$(LISTFILE_DIRECTORY)/vz200.lst

# VZ200 ansi lib - Stefano
vzansi_clib.lib:
	@echo ''
	@echo '--- Building VZ200/300 ANSI Library  ---'
	@echo ''
	$(MAKE) gfxdeps
	cd strings ; $(MAKE) ; cd ..
	cd stdlib ; $(MAKE) gen ; cd ..

=== test/Makefile ===



SUBDIRS = machine suites

all: subdirs-all


subdirs-all: $(SUBDIRS)


clean: subdirs-clean

subdirs-clean:
	@for s in $(SUBDIRS); \
	do \
		$(MAKE) -C $$s clean ; \
	done


.PHONY:	subdirs-all $(SUBDIRS)

$(SUBDIRS):
	$(MAKE) -C $@ all

=== examples/embedded/Makefile ===

all: embedded_clib2.lib hello.bin sine.bin loop.bin savage.bin

embedded_clib2.lib: fputc_cons.asm fgetc_cons.asm
	z80asm -d -ns -nm -Mo -DFORembedded -xembedded_clib2 @clib2.lst

ns16450.o: embedded_clib2.lib ns16450.h ns16450.c
	zcc +embedded -c ns16450.c 

hello.bin: embedded_clib2.lib ns16450.o hello.c
	zcc +embedded ns16450.o hello.c -o hello.bin

sine.bin: embedded_clib2.lib ns16450.o sine.c
	zcc +embedded -lm ns16450.o sine.c -o sine.bin

loop.bin: embedded_clib2.lib ns16450.o loop.c
	zcc +embedded -lm ns16450.o loop.c -o loop.bin

savage.bin: embedded_clib2.lib ns16450.o savage.c
	zcc +embedded -lm ns16450.o savage.c -o savage.bin

clean:
	$(RM) *.bin *.i *.lib *.op* *.o *~ zcc_opt.def

=== examples/rcmx000/Makefile ===
# Z88DK - Rabbit Control Module examples
#
# $Id: Makefile,v 1.3 2008/02/26 12:37:22 aralbrec Exp $

# You NEED to set this to your baudrate divisor and your serial port
SERDEVICE=/dev/ttyXXX
BAUD_DIV=XXX


all: example.bin twinkle2000.bin twinkle3000.bin

SUPPORT=/usr/local/lib/z88dk/support/rcmx000



example.bin: example.c
	zcc +rcmx000 -oexample.bin example.c


twinkle2000.bin:
	zcc +rcmx000 -otwinkle2000.bin twinkle2000.c

twinkle3000.bin:
	zcc +rcmx000 -otwinkle3000.bin twinkle3000.c


run_example:
	$(SUPPORT)/boot -b $(SERDEVICE) $(BAUD_DIV) example.bin

run_twinkle2000:
	$(SUPPORT)/boot -b $(SERDEVICE) $(BAUD_DIV) twinkle2000.bin

run_twinkle3000:
	$(SUPPORT)/boot -b $(SERDEVICE) $(BAUD_DIV) twinkle3000.bin

clean:
	rm -f *.bin ; rm -f *.LOD ; rm -f tmp_* ; rm -f zcc_opt.def ; \
        rm -f *~ ; rm -f #* ; rm -f *#

=== examples/sam/Makefile ===
PROGS = hello keyget dstar enigma gfx smile cube mandel ansi

all: $(PROGS)


hello:	hello.c
	zcc +sam -vn hello.c -o hello

keyget: keyget.c
	zcc +sam -vn keyget.c -o keyget

gfx:	gfx.c
	zcc +sam -vn gfx.c -o gfx

graygfx:
	zcc +sam -vn graygfx.c -o graygfx

smile:  smile.c
	zcc +sam -vn smile.c -o smile

cube:	cube.c
	zcc +sam -vn cube.c -o cube -lm

dstar:  dstar.c dstar.h
	zcc +sam -vn dstar.c -o dstar

enigma: enigma.c
	zcc +sam -vn enigma.c -o enigma

mandel: mandel.c
	zcc +sam -vn mandel.c -o mandel -lm

rpn:
	zcc +sam -vn rpn.c -o rpn -lndos

adv:
	zcc +sam -vn adv_a.c -o adv_a -lndos

ansi:
	zcc +samansi -vn ansitest.c -o ansitest -lndos


clean:
	$(RM) *.i *.asm *.op* *.o *~ zcc_opt.def $(PROGS)

=== examples/sms/Makefile ===

all: test.sms libctest.sms pongmstr.sms pngmstr2.sms apktest.sms chicken.sms testsnd.sms

test.sms: test.c
	zcc +sms test.c -o test.sms -m
	echo test.map test.sym
	
libctest.sms: libctest.c
	zcc +sms libctest.c -o libctest.sms -m
	echo libctest.map libctest.sym

pong_graphics.o: pong_graphics.asm batnball.til numbers.til bkg.til icons.til
	z80asm -d -ns -nm -Mo pong_graphics.asm

testtxt_apk.o: testtxt_apk.asm testtxt.apk
	z80asm -d -ns -nm -Mo testtxt_apk.asm

pongmstr.sms: pong_graphics.o pongmstr.c
	zcc +sms pong_graphics.o pongmstr.c -o pongmstr.sms -m -create-app
	echo pongmstr.map pongmstr.sym

pngmstr2.sms: pong_graphics.o pngmstr2.c
	zcc +sms pong_graphics.o pngmstr2.c -o pngmstr2.sms -m -create-app
	echo pngmstr2.map pngmstr2.sym

apktest.sms: testtxt_apk.o apktest.c
	zcc +sms testtxt_apk.o apktest.c -o apktest.sms -m -create-app
	echo apktest.map apktest.sym

chicken_graphics.o: chicken_graphics.asm road.til sidewalk.til car1.til
	z80asm -d -ns -nm -Mo chicken_graphics.asm

chicken.sms: chicken_graphics.o chicken.c
	zcc +sms chicken_graphics.o chicken.c -o chicken.sms -m -create-app
	echo chicken.map chicken.sym

testsnd.sms: testsnd.c
	zcc +sms testsnd.c -o testsnd.sms -m -create-app
	echo testsnd.map testsnd.sym

clean:
	$(RM) *.bin *.i *.lib *.op* *.o *~ zcc_opt.def

=== examples/spectrum/Makefile ===


all: dstar ansitest gfx save


save:
	zcc +zx -vn save.c -o save.bin

gfx:
	zcc +zx -vn gfx.c -o gfx.bin -lndos

dstar:
	zcc +zx -vn dstar.c -o dstar.bin -lndos

ansitest:
	zcc +zxansi -vn ansitest.c -o ansitest.bin -lndos


clean:
	$(RM) *.bin *.i *.asm *.op* *.o *~ zcc_opt.def

=== examples/z88/Makefile ===

all: info ansitest cube cubez88 dstar gfx

all16: info anstst16 cube cubez88 dstar gfx

info:
	@echo Building examples..

ansitest:
	- zcc +z88 -lz88ansi_clib ansitest.c -o ansitest.bas

anstst16:
	- zcc +z88 -lz88ans~1 ansitest.c -o ansitest.bas

cube:
	- zcc +z88 -lm -lgfx cube.c -o cube.bas

cubez88:
	- zcc +z88 -lmz -lgfx cube.c -o cubez88.bas

dstar:
	- zcc +z88 -lgfx dstar.c -o dstar.bas

gfx:
	- zcc +z88 -lgfx gfx.c -o gfx.bas

clean:
	$(RM) ansitest.bas cube.bas cubez88.bas dstar.bas gfx.bas 
	$(RM) zcc_opt.def *.op* *.o *.i *.asm *.err *.map *.sym

=== examples/zxvgs/Makefile ===


all: info


info:
	zcc +zx -Cz+zxvgs -v -s info.c -create-app -lzxvgs

clean:
	rm -f *.bin *.i *.asm *.op* *.o *~ zcc_opt.def

=== libsrc/adt/Makefile ===
#
# Wahey, a messed up makefile for building libraries!
#

include ../Make.config

all: 
	$(LIBLINKER) -x../$(OUTPUT_DIRECTORY)/adt @adt.lst

clean:
	cd hashtable ; $(RM) *.o* *.sym *.map zcc_opt.def ; cd ..
	cd heap ; $(RM) *.o* *.sym *.map zcc_opt.def ; cd ..
	cd linkedlist ; $(RM) *.o* *.sym *.map zcc_opt.def ; cd ..
	cd stack ; $(RM) *.o* *.sym *.map zcc_opt.def ; cd ..
	cd queue ; $(RM) *.o* *.sym *.map zcc_opt.def ; cd ..

=== libsrc/algorithm/Makefile ===
#
# Wahey, a messed up makefile for building libraries!
#
# $Id: Makefile,v 1.2 2007/06/04 05:54:11 stefano Exp $

include ../Make.config

default:
	$(LIBLINKER) -x../$(OUTPUT_DIRECTORY)/algorithm @alg.lst

clean:
	$(RM) *.o* *.sym *.map *~ *.err zcc_opt.def *.i 
	cd AStarSearch ; $(RM) *.o* *.sym *.map *~ *.err zcc_opt.def *.i ; cd ..

=== debian/changelog ===
z88dk (1.8.ds1-10) unstable; urgency=low

  [ Krystian Wlosek ]
  * fixed bug with incorrect path in cfg files (Closes: #653110)

 -- Krystian Wlosek <kwlosek@gmail.com>  Tue, 29 May 2012 12:07:24 +0200

z88dk (1.8.ds1-9) unstable; urgency=low

  [ Piotr Roszatycki ]
  * Source package converted to debhelper command sequencer with quilt format.
  * Added patch for "-Werror=format-security" with new GCC.

 -- Piotr Roszatycki <dexter@debian.org>  Thu, 27 Oct 2011 16:08:16 +0200

z88dk (1.8.ds1-8) unstable; urgency=low

  [ Krystian Wlosek ]
  * Added Danish defconf translation. (Closes: #625470)
    Patch by Joe Dalton.
  * update po/tempates.pot (change email address)

 -- Krystian Wlosek <kwlosek@gmail.com>  Tue, 10 May 2011 08:57:14 +0100

z88dk (1.8.ds1-7) unstable; urgency=low

  [ Krystian Wlosek ]
  * Apply patch for 64bit architectures. Remove -m32 flag from LDFLAGS.
    (Closes: #570681)
  * Added Spanish defconf translation. (Closes: #578350)
    Patch by Ricardo Fraile.
  * Add z88dk-data as depend in z88dk-bin package.

 -- Krystian Wlosek <kwlosek@gmail.com>  Thu, 22 Apr 2010 15:13:27 +0100

z88dk (1.8.ds1-6) unstable; urgency=high

  [ Krystian Wlosek ]
  * Change maintainer email from tygrys@waw.pdi.net to kwlosek@gmail.com
  * Build-Depends: change freebsd-amd64 to kfreebsd-amd64 (Closes: #537084)
    Thanks to Petr Salinger
  * Fixed FTBFS problem with src/z80asm/z80pass.c (Closes: #552886)
    Added patch debian/patches/05_src_z80asm_z80pass.c.diff
    Thanks to Lucas Nussbaum
  * Bump standards version to 3.8.3. No changes needed.

 -- Krystian Wlosek <kwlosek@gmail.com>  Tue, 01 Dec 2009 22:41:10 +0100

z88dk (1.8.ds1-5) unstable; urgency=low

  [ Krystian Wlosek ]
  * Added Japanese debconf translation. (Closes: #512868)
    Patch by Hideki Yamane.
  * Added Russian debconf translation. (Closes: #514508)
    Patch by Yuri Kozlov.

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Tue, 23 Feb 2009 11:10:17 +0100

z88dk (1.8.ds1-4) unstable; urgency=low

  * Fixed problem with CPC binaries (Closes: #475605)
    Added patch debian/patches/02_lib_cpc_crt0.asm.diff

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Thu, 17 Oct 2008 11:45:12 +0200

z88dk (1.8.ds1-3) unstable; urgency=low

  * Added Swedish debconf translation. (Closes: #500127)
    Patch by Martin Bagge.
  * Bump standards version to 3.8.0. Added 'set -e' in config scripts.

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Wed, 15 Oct 2008 14:28:51 +0200

z88dk (1.8.ds1-2) unstable; urgency=low

  [ Krystian Wlosek ]
  * Enable 64bit architecture.
  * Added '-m32' switch to CFLAGS and LDFLAGS for 64bit machines.
  * Changed Architecture: to `any' in z88dk and z88dk-bin package.
  * Added gcc-multilib to Build-Depends: for 64bit
  * Fixed problem with x11.lib
    - created symlink from include/x11 to include/X11
    - improved Makefile for x11.lib
      patch debian/patches/03_libsrc_graphics_x11_Makefile.diff
  * Fixed library ozansi.lib
    - patch debian/patches/03_libsrc_oz_ozinput_Makefile.diff
  * Changed Copyright notice.
  * Fixed gcc warnings:
    - in src/appmake dir - debian/patches/04_src_appmake.diff
    - in src/zcc/zcc.c - debian/patches/04_src_zcc_zcc.c.diff

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Tue, 25 Mar 2008 11:46:11 +0100

z88dk (1.8.ds1-1) unstable; urgency=low

  [ Krystian Wlosek ]
  * New upstream release.
  * Added missing arch: armel armeb to z88dk. Thanks to Martin Guy.
    Closes: #469967

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Mon, 10 Mar 2008 11:01:25 +0100

z88dk (1.7.ds1-2) unstable; urgency=low

  [ Krystian Wlosek ]
  * Added Dutch debconf translation. (Closes: #449401)
    Patch by Bart 'cobaco' Cornelis.
  * Added missing libraries: malloc.lib, mzx.lib, mzx_tiny.lib
    z88_math.lib and make propper diff files.
    Thanks to Josetxu Malanda.

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Wed, 27 Feb 2008 11:56:25 +0100

z88dk (1.7.ds1-1) unstable; urgency=low

  [ Krystian Wlosek ]
  * New upstream release.
    Closes: #438984
  * Added missing colon to close bug 435364

  [ Piotr Roszatycki ]
  * Changed section for z88dk-doc package.
  * Standards-Version: 3.7.3

 -- Piotr Roszatycki <dexter@debian.org>  Mon, 07 Jan 2008 13:35:53 +0100

z88dk (1.6.ds1-7) unstable; urgency=low

  * Added Portuguese debconf translation. (Closes: #434194)
    Thanks to Americo Monteiro.
  * Added armel and armeb to z88dk-bin/Architecture: (Closes: #435364)

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Mon, 27 Aug 2007 12:35:28 +0200

z88dk (1.6.ds1-6) unstable; urgency=low

  * Added forgotten Replaces: in z88dk-data.
    Thanks to Mark Robinson <mark@zl2tod.net> (Closes: #423475)

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Tue, 14 May 2007 15:37:20 +0200

z88dk (1.6.ds1-5) unstable; urgency=low

  * New package z88dk-data with non-arch specific files.
  * Added hurd and m68k to z88dk-bin/Architecture.
  * Added German debconf translation. (Closes: #408650)
    Patch by Helge Kreutzmann <debian@helgefjell.de>.
  * Changed Architecture for z88dk from 'all' to this same as in z88dk-bin.
  * Moved files of z88dk-examples to z88dk-doc.

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Tue,  8 May 2007 15:37:20 +0200

z88dk (1.6.ds1-4) unstable; urgency=low

  * s390 is 32bit archtecture. Closes: #405013, #405264
    Thanks to Bastian Blank, Steve Langasek.
  * arm already added to z88dk-bin/Architecture:
    Thanks to Steve Langasek.

 -- Krystian Wlosek <tygrys@waw.pdi.net>  Mon,  8 Jan 2007 09:42:21 +0100

z88dk (1.6.ds1-3) unstable; urgency=low

  * Recompile with new yada without templates problems.
  * Added missing arm architecture
  * Added exit in build script when buildd try compile for
    64bit architectures: s390,alpha,amd64,ia64,ppc64 (Closes: #395263)
  * Added Czech debconf translation (Closes: #402985)
    Thanks to Jakub Kasparec.
  * conflict with z80asm package. z88dk-bin overwrite manpage in z80asm
    symlink from z88dk-z80asm.1 to z80asm.1 removed.
    Thanks to Michael Ablassmeier, (Closes: #404012)


=== debian/control ===
Source: z88dk
Maintainer: Krystian Wlosek <kwlosek@gmail.com>
Uploaders: Piotr Roszatycki <dexter@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.2
Build-Depends: po-debconf, debhelper (>= 8.9.7)
Homepage: http://www.z88dk.org/
Vcs-Browser: http://bazaar.launchpad.net/~z88dk-team/z88dk-pkg/sid/files
Vcs-Bzr: lp:z88dk-pkg

Package: z88dk-bin
Architecture: any
Depends: z88dk-data (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: executable files for z88dk
 z88dk is a Z80 processor cross compiler producing binaries for over
 25 different z80 based machines. This package contains binary files.

Package: z88dk-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Provides: z88dk-examples
Conflicts: z88dk-examples
Replaces: z88dk-examples
Description: documentation and examples for z88dk
 This is documentation for z88dk compilers. Also example programs with sources
 are available. See the z88dk package for more details.

Package: z88dk-data
Architecture: all
Depends: ${misc:Depends}
Replaces: z88dk
Description: data files for z88dk
 This package contains any data files needed by z88dk tools.

Package: z88dk
Architecture: any
Depends: z88dk-bin (>= ${source:Version}), z88dk-bin (<< ${source:Version}.1~),
         z88dk-data (= ${source:Version}),
         ${misc:Depends}
Suggests: z88dk-doc, z88dk-examples
Description: Z80 processor assembler and SmallC+ cross compiler
 z88dk is a SmallC+ and Z80 assemler cross compiler supplied with an
 assembler/linker and a set of libraries implementing the C standard library
 for a number of different z80 based machines. The name z88dk originates from
 the time when the project was founded and supported only the Cambridge
 z88 portable.
 .
 Supported machines:
 Cambridge Computers z88, Sinclair ZX Spectrum, Sinclair ZX81, CP/M based
 machines, Amstrad NC100, VZ200/300, Sharp MZ series, TI calculators (TI82,
 TI83, TI83+, TI85, TI86), ABC80, Jupiter Ace, Xircom REX 6000, Peters
 Sprinter, Sam Coupe, MSX1, Spectravideo, Mattel Aquarius, Peters Sprinter,
 and C128 (in z80 mode) machines.
 .
 Features:
  * Small C+ based compiler with structs, floats and other ANSI extensions
  * Module assembler/linker which only includes required library routines
  * Peephole optimizer with rulesets that reduce the size of generated code
    by ~30% and improve speed
  * Easily retargetted C library including stdio routines
  * Retargettable VT100 terminal
  * Support for over a 25 z80 based machines (see below for details)

=== debian/rules ===
#!/usr/bin/make -f

pwd = $(shell pwd)

%:
	dh $@

override_dh_auto_clean:
	make clean || true
	rm -rf bin usr debian/tmp debian/usr

override_dh_auto_configure:
	rm -rf bin usr
	mkdir -p bin usr
	rm -f include/X11
	ln -s x11 include/X11
	find examples -type f -exec chmod 644 {} \;
	find examples -type d -exec chmod 755 {} \;

override_dh_auto_build-arch:
	make -e prefix=/usr

override_dh_auto_build-indep: override_dh_auto_build-arch
	# create symlink 
	PATH=$(pwd)/bin:$(PATH) Z80_OZFILES=$(pwd)/lib/ ZCCCFG=$(pwd)/lib/config/ make -C $(pwd)/libsrc

override_dh_auto_install-arch:
	make -e prefix=$(pwd)/debian/tmp/usr install
	rm -f debian/tmp/usr/bin/*
	for i in bin/*; do cp $$i debian/tmp/usr/bin/z88dk-$$(basename $$i); done
	mkdir -p debian/tmp/usr/share/man/man1
	rm -f debian/tmp/usr/share/man/man1/*
	for i in debian/manpages/*.1; do cp $$i debian/tmp/usr/share/man/man1/z88dk-$$(basename $$i); done
	rm -f debian/tmp/usr/share/man/man1/z88dk-z88dk.1

override_dh_auto_install-indep: override_dh_auto_install-arch
	make -C $(pwd)/libsrc install
	make prefix=/usr DESTDIR=$(pwd)/debian install
	make -e prefix=$(pwd)/debian/tmp/usr install-libs
	mv -f debian/tmp/usr/lib/z88dk/lib/clibs/* debian/tmp/usr/share/z88dk/lib/clibs
	./config.sh /usr/share/z88dk/ z88
	cp -a lib/config/*.cfg debian/tmp/usr/share/z88dk/lib/config/
	rm -f debian/tmp/usr/share/z88dk/lib/config/zcc.cfg
	rm -f debian/tmp/usr/share/z88dk/lib/config/*.lnx
	for i in debian/tmp/usr/share/z88dk/lib/config/*.cfg; do \
	   mv $$i $$i.tmp; cat $$i.tmp | \
	       sed 's/^Z80EXE.*$$/Z80EXE\t\tz88dk-z80asm/g' | sed 's/^CPP.*$$/CPP\t\tz88dk-zcpp/g' | \
	       sed 's/^LINKER.*$$/LINKER\t\tz88dk-z80asm/g' | sed 's/^COMPILER.*$$/COMPILER\tz88dk-sccz80/g' | \
	       sed 's/^COPTEXE.*$$/COPTEXE\t\tz88dk-copt/g' | sed 's/^APPMAKER.*$$/APPMAKER\tz88dk-appmake/g' > $$i; \
	   rm $$i.tmp; \
	done

## z88dk 1.8.ds1-9+6.0.1trisquel1

=== debian/changelog ===
z88dk (1.8.ds1-9+6.0.1trisquel1) toutatis; urgency=low

  * Remove unrequired nonfree files

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 24 Jan 2015 23:11:11 +0000

## z88dk 1.8.ds1-10+7.0trisquel1

=== libsrc/graphics/x11/Makefile ===
#
# Makefile for X-Motif graphics emulation
#
# $Id: Makefile,v 1.2 2008/03/05 20:35:46 dom Exp $

include ../../Make.config

CFILES = \
	blackpixel.c \
	defaultdepth.c \
	defaultscreen.c \
	displayheight.c \
	displaywidth.c \
	rootwindow.c \
	whitepixel.c \
	xchecktypedevent.c \
	xcheckwindowevent.c \
	xclearwindow.c \
	xclosedisplay.c \
	xcreatebitmapfromdata.c \
	xcreategc.c \
	xcreatesimplewindow.c \
	xdestroywindow.c \
	xdisplayname.c \
	xdrawline.c \
	xdrawpoint.c \
	xdrawrectangle.c \
	xdrawstring.c \
	_xfindchar.c \
	xflush.c \
	_xfputc.c \
	xfreegc.c \
	xloadqueryfont.c \
	xmapwindow.c \
	xnextevent.c \
	xopendisplay.c  \
	xselectinput.c \
	xsetdashes.c \
	xsetfont.c \
	xsetforeground.c \
	xsetlineattributes.c \
	xsetstandardproperties.c \
	xtextwidth.c \
	xunloadfont.c 


AFILES  = $(CFILES:.c=.asm)
OBJECTS = $(CFILES:.c=.o)

all: x11lib

x11lib: $(OBJECTS)
	$(LIBLINKER) -x../../x11.lib @x11.lst

.c.o:
	zcc +test $(CFLAGS) $*.c

clean:
	$(RM) *.o* zcc_opt.def

=== libsrc/oz/ozinput/Makefile ===
#
# Makefile for OZ-7xx specific libraries - ozinput
#
# $Id: Makefile,v 1.3 2008/03/05 20:35:47 dom Exp $

include ../../Make.config

all:	
	zcc +ozansi $(CFLAGS) *.c

clean:
	$(RM) *.o* zcc_opt.def

=== debian/changelog ===
z88dk (1.8.ds1-10+7.0trisquel1) belenos; urgency=medium

  * Remove unrequired nonfree files

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 24 Jan 2015 23:09:33 +0000

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: z88dk
-Maintainer: Krystian Wlosek <kwlosek@gmail.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 Uploaders: Piotr Roszatycki <dexter@debian.org>
 Section: devel
 Priority: extra
